
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>使用PyQt来编写第一个Python GUI程序 / iVAN</title>

    <meta name="description" content="使用PyQt来编写第一个Python GUI程序 原文:使用PyQt来编写第一个Python GUI程序 本文由 伯乐在线 - Lane 翻译,Daetalus 校稿.未经许可,禁止转载!英文出处:pythonforengineers.com.欢迎加入翻译小组. 简介 许多人在学习如何创建一个 GUI 应用的时候都感到十分的困难.其中最重要的原因是,他们不知道应该从何下手.大多数的教程都只有文字,但事实上仅仅依靠文字很难学会 GUI 编程,因为 GUI 应用大多数都是基于视觉上的. 我们将通过创建一个简单的 GUI 应用来避免上面提到的这些问题">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">使用PyQt来编写第一个Python GUI程序</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原文:<a href="http://www.cnblogs.com/rrxc/p/4462890.html" rel="external nofollow noreferrer">使用PyQt来编写第一个Python GUI程序</a><br />
<br />本文由 <a href="http://python.jobbole.com/" rel="external nofollow noreferrer">伯乐在线</a> - <a href="http://python.jobbole.com/author/zhanglintc/" rel="external nofollow noreferrer">Lane</a> 翻译，<a href="http://python.jobbole.com/author/daetalus/" rel="external nofollow noreferrer">Daetalus</a> 校稿。未经许可，禁止转载！<br />英文出处：<a href="http://pythonforengineers.com/your-first-gui-app-with-python-and-pyqt/" rel="external nofollow noreferrer">pythonforengineers.com</a>。欢迎加入<a href="http://www.jobbole.com/groups/6/?utm_source=jobboleblog-article" rel="external nofollow noreferrer">翻译小组</a>。</p>
<p><strong>简介</strong></p>
<p>许多人在学习如何创建一个 GUI 应用的时候都感到十分的困难。其中最重要的原因是，他们不知道应该从何下手。大多数的教程都只有文字，但事实上仅仅依靠文字很难学会 GUI 编程，因为 GUI 应用大多数都是基于视觉上的。</p>
<p>我们将通过创建一个简单的 GUI 应用来避免上面提到的这些问题，并且向你展示着手开始这件事其实是多么的简单。一旦你明白了这些基本的知识，以后的进一步学习将会变得十分的容易。</p>
<p>这就是我们即将完成的东西：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180YWEyNTBkZDQwMjk2MzNkYjVkMjQ0NGU0MjNlZDk5NC5qcGc=.jpg"></p>
<p>这是一个简单的 GUI 应用，根据输入的价格（price）和税率（tax rate），计算出最终的价格（final price）。</p>
<p>大多数的教程都试图直接通过代码来对 GUI 应用进行布局，但是这样做实在是很费劲。我们将要做的是利用优秀的 QT Designer 工具来对我们的应用进行布局。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19kNjUyMGNhOWQwNGZlZTQzNjBiNjhiNDU5YzNmMmI4OS5qcGc=.jpg"></p>
<p>所以不要再劳神费力的用代码来设计界面了。现在开始所有的东西都将通过图形界面来搞定。</p>
<p>所有的<a href="https://github.com/shantnu/PyQt_first" rel="external nofollow noreferrer">代码都在这里</a>。</p>
<p><strong>前提条件</strong></p>
<p>如果你已经<a href="http://pythonforengineers.com/python-on-windows-causing-you-pain-try-anaconda/" rel="external nofollow noreferrer">接受了我的建议</a>并且安装了 <a href="http://continuum.io/downloads" rel="external nofollow noreferrer">Anaconda</a>，你应该已经安装好了 PyQt4。如果没有的话，你需要从<a href="http://www.riverbankcomputing.co.uk/software/pyqt/download" rel="external nofollow noreferrer">这里</a>先下载它。</p>
<p>同时你还需要一个 Qt Designer。我建议你<a href="https://www.qt.io/download-open-source/" rel="external nofollow noreferrer">下载</a>整个的 QT 套件，因为其中还包含了许多其他有用的工具。</p>
<p><strong>开始着手</strong></p>
<p>提示：当你需要查看更多细节的时候，你可以通过点击下方的任意图片来查看其原图。（译者注：你可能需要查看原始链接来查看原图）</p>
<p>打开 QT Designer。在弹出的窗口中，选择 Main Window，这样它会给你一个空白的画板。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19iYjcyNjY4NjVhYTBlMTljNjc5ZjZlZjJmYzBmMmNkZi5qcGc=.jpg"></p>
<p>接下来在左侧选择<code>Text Edit</code>：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ184Nzc1MDExMjc0ODhkMTYxOTkzM2ZmNzJiMzdkMjQyNC5qcGc=.jpg"></p>
<p>将<code>Text Edit</code> 拖动到主窗口：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19kOWNlZThkNzYzNzg1MDc5MjRhZjNlMmJmMTcyZTU3MC5qcGc=.jpg"></p>
<p>看见右边我粗略的用红圈框起来的部分了吗？那就是定义这个对象的名字的地方。这个名字将是我们通过 Python 代码调用到这个对象的变量名，所以请尽量取一个有意义的名称。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18zNzg5YmNmNWY4ZWQ4N2QyNTdjNWViZTBiYTA2OGNlMy5qcGc=.jpg"></p>
<p>我将它取名为<code>price_box</code>，因为我们会在这里输入价格。然后我们需要给这个输入框添加一个 label，以便让用户更加清楚这个输入框的作用。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19kZDExNjM2NWQ4OGM2M2RjNDc2YjVjZWI2YjI2ZTMxYS5qcGc=.jpg"></p>
<p>我在上图中圈出了 label。把它拖动到主窗口当中来。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MzE0ZGUzZDlkNDkwMzk1NzFjODczMTVhYjNhODg4Zi5qcGc=.jpg"></p>
<p>现在它被默认称作<code>TextLabel</code>。双击并将其命名为<code>Price</code>。你还可以将这段文字字体加大并且设置为粗体，就像下边看到的这样：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MTc2MTkzOTc4NGQ3ZDlkNWEwYmNhMTEwOGVmZDBhYS5qcGc=.jpg"></p>
<p>对于税率（tax）输入框，我们会使用另外的一个东西。找到<code>spin box</code>：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19mNDQ5NDlmMjBhYjczY2U4Y2VhYTQxNjVmZmUzYTY3OC5qcGc=.jpg"></p>
<p>左侧用圈框起来的部分就是一个<code>spin box</code>。它会限定你能输入的值。其实并不是非得要用<code>spin box</code>，这样做只不过是为了更好地展示 QT Creator 所能提供的各种不同的组件。将<code>spin box</code> 拖到窗口中。然后我们要做的第一件事情就是将<code>objectName</code> 改为一个有意义的名字，例如我将其设置为<code>tax_rate</code>。请记住这将会是你在 Python 代码中调用它的时候会使用到的变量名。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19kOWU4YTczZGY2MjIyMzFiZjQ5M2U0NGNmYmYzNDM4Zi5qcGc=.jpg"></p>
<p>我们可以为我们的<code>spin box</code> 设置一个默认值。我选择将其设置为 20：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19mMGEwNjkzMGFmYTNlMjJjNmZmMjA3MWU2MjczZWU2ZC5qcGc=.jpg"></p>
<p>如果你仔细观察上图，你会发现我们也可以设置它的最小值和最大值。不过我并不打算去更改他们。</p>
<p>同样地，我会为它添加一个标签叫做<code>Tax Rate</code>。然后看看我们接下来会用到的圈起来的<code>Push Button</code>：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19lNTM5OWE5ZjQzYmVmMDgxYmVkNjNiNzc5YzRmNGFkYi5qcGc=.jpg"></p>
<p>好的，现在选择<code>Push Button</code> 然后将其拖动到我们的窗口中来。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18yM2QxNmQ5M2Q0Yzk5YzRjMjE0MDEwMWVkNDEyMzVkNy5qcGc=.jpg"></p>
<p>这个按钮现在显示的是<code>PushButton</code>，这并不是一个很有意义的名字。到了这一步，你应该知道该怎么更改它了。不过在此之前，我们要把这个按钮的名字（不是显示用的文字列）改为<code>calc_tax_button</code>。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ183ZThmZGVhNTE4YmQ3YWY3MDFjNzIyMDdjODVmODQ2ZC5qcGc=.jpg"></p>
<p>然后，我们可以修改真正的显示文字列了：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xMTZmNWE1NDI1NGM4ZjY5Mzc2NDc2ZjA2YTZlODc3OS5qcGc=.jpg"></p>
<p>然后选择另外一个<code>Text Edit</code> 并将其拖动到窗口中。你不需要给它添加标签，因为我们会把我们的结果输出到这里。把它的名字改为<code>results_window</code>（下图中没有画出来，但你应该已经知道该如何操作了）。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hYjZlZTkwNTQ2ZGRjZGMwYmJmN2VmMjQwMmMyNjVjYy5qcGc=.jpg"></p>
<p>如果你觉得需要的话，你可以添加一个大标题。这是一个简单的<code>label box</code> 并且将字体加大了。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19jMjBlZjZhYzBhOWM1MTFmODU1NDhkNDA0MjIxYWE5Ny5qcGc=.jpg"></p>
<p>现在保存你的成果：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19lZmRkNzA3MDRhY2E3NDA5YWJhMTIzOTBlNDAyNmE5ZC5qcGc=.jpg"></p>
<p>这个文件在下一部分我们编写代码的时候将会用到，所以最好把它存在一个我们方便访问的地方。</p>
<p>我们创建的只是一个简单的 XML 文件。用任意一个文本编辑器打开它，你可以看到这样的内容：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19lOWQ4YmI0OTljZGUwOTI1NjcxZDk3N2VkMjQzYzgxNi5qcGc=.jpg"></p>
<p><strong>编写代码</strong></p>
<p>Qt 代码是面向对象的，并且简单易学。所有我们添加的组件都是一个对象，并且都拥有自己的方法比如<code>toPlainText()</code>（用来读取输入框中的值）。这让它使用起来非常方便。</p>
<p>在你编写代码之前，你必须要使用一些函数来进行配置。我确信官方的文档中肯定有提到过这个，但是我现在打死也找不到这些文档了，所以我只能通过官方的例程（以及网上的一些教程）中总结出了这一小段代码来进行配置。我已经把这些函数上传到了 <a href="https://github.com/shantnu/PyQt_first/blob/master/pyqt_skeleton.py" rel="external nofollow noreferrer">pyqt_skeleton.py</a>。</p>
<p>这些代码非常有用，每当你想要创建一个新的 PyQt 项目的时候，就在这段代码的基础上添加你自己的代码吧。</p>
<p>这段代码如下：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
</td>
<td>
<p><code>import</code> <code>sys</code></p>
<p><code>from</code> <code>PyQt4 </code><code>import</code> <code>QtCore, QtGui, uic</code></p>
<p> </p>
<p><code>qtCreatorFile </code><code>=</code> <code>"" </code><code># Enter file here.</code></p>
<p> </p>
<p><code>Ui_MainWindow, QtBaseClass </code><code>=</code> <code>uic.loadUiType(qtCreatorFile)</code></p>
<p> </p>
<p><code>class</code> <code>MyApp(QtGui.QMainWindow, Ui_MainWindow):</code></p>
<p><code>    </code><code>def</code> <code>__init__(</code><code>self</code><code>):</code></p>
<p><code>        </code><code>QtGui.QMainWindow.__init__(</code><code>self</code><code>)</code></p>
<p><code>        </code><code>Ui_MainWindow.__init__(</code><code>self</code><code>)</code></p>
<p><code>        </code><code>self</code><code>.setupUi(</code><code>self</code><code>)</code></p>
<p> </p>
<p><code>if</code> <code>__name__ </code><code>=</code><code>=</code> <code>"__main__"</code><code>:</code></p>
<p><code>    </code><code>app </code><code>=</code> <code>QtGui.QApplication(sys.argv)</code></p>
<p><code>    </code><code>window </code><code>=</code> <code>MyApp()</code></p>
<p><code>    </code><code>window.show()</code></p>
<p><code>    </code><code>sys.exit(app.exec_())</code></p>
</td>
</tr>
</tbody>
</table>
<p>其中需要注意的是第三行：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
</td>
<td>
<p><code>qtCreatorFile </code><code>=</code> <code>"" </code><code># Enter file here.</code></p>
</td>
</tr>
</tbody>
</table>
<p>你需要在这里填入你先前创建的文件的地址。这个文件将会被内置的函数载入:</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
</td>
<td>
<p><code>Ui_MainWindow, QtBaseClass </code><code>=</code> <code>uic.loadUiType(qtCreatorFile)</code></p>
</td>
</tr>
</tbody>
</table>
<p>让我们大致地看一看这段代码：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
</td>
<td>
<p><code>if</code> <code>__name__ </code><code>=</code><code>=</code> <code>"__main__"</code><code>:</code></p>
<p><code>    </code><code>app </code><code>=</code> <code>QtGui.QApplication(sys.argv)</code></p>
<p><code>    </code><code>window </code><code>=</code> <code>MyApp()</code></p>
<p><code>    </code><code>window.show()</code></p>
<p><code>    </code><code>sys.exit(app.exec_())</code></p>
</td>
</tr>
</tbody>
</table>
<p>这段主程序创建了一个新的 Qt Gui 应用。，每个 QT 应用都可以通过命令行进行配置，所以必须传入<code>sys.argv</code> 参数。不过现在我们用不到这个。最后，我们创建了一个<code>MyApp</code> 类，这个类继承于 Qt 库并且调用了父类的初始化函数：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
</td>
<td>
<p><code>class</code> <code>MyApp(QtGui.QMainWindow, Ui_MainWindow):</code></p>
<p><code>    </code><code>def</code> <code>__init__(</code><code>self</code><code>):</code></p>
<p><code>        </code><code>QtGui.QMainWindow.__init__(</code><code>self</code><code>)</code></p>
<p><code>        </code><code>Ui_MainWindow.__init__(</code><code>self</code><code>)</code></p>
<p><code>        </code><code>self</code><code>.setupUi(</code><code>self</code><code>)</code></p>
</td>
</tr>
</tbody>
</table>
<p>你不一定非得要了解这些代码的细节。你只需要在它的基础上继续开发就好了。</p>
<p>下载<code>pyqt_skeleton.py</code> 这个文件，并将它重命名为<code>pyqt_first.py</code>。这是因为我们不想去改动到源文件。然后要做的第一件事就是在代码中导入我们自己的 XML 文件，这个 XML 文件包含了我们的这个 GUI 信息。将下面的这一行：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
</td>
<td>
<p><code>qtCreatorFile </code><code>=</code> <code>"" </code><code># Enter file here.</code></p>
</td>
</tr>
</tbody>
</table>
<p>替换为</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
</td>
<td>
<p><code>qtCreatorFile </code><code>=</code>  <code>"tax_calc.ui"</code></p>
</td>
</tr>
</tbody>
</table>
<p>这样就能把我们的 GUI 文件载入到内存中。现在，我们的 GUI 中最关键的组件就是我们的这个按钮了。一旦我们按下这个按钮，就会发生一些神奇的事情。到底会发生什么？这就需要我们告诉代码当按下<code>Calculate Tax</code> 按钮的时候该怎么做了。在<code>__init__</code> 函数中，添加如下的内容：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
</td>
<td>
<p><code>self</code><code>.calc_tax_button.clicked.connect(</code><code>self</code><code>.CalculateTax)</code></p>
</td>
</tr>
</tbody>
</table>
<p>这段代码有什么用？还记得我们把按钮命名为了<code>calc_tax_button</code> 吗？（这是这个按钮对象的名字，不是按钮上显示的提示字符串。）<code>clicked</code> 是一个内置的函数，当有按钮被点击的时候它会被自动调用（很神奇吧）。所有的 QT 组件都有特定的函数，你可以通过 Google 来查看详细。这段代码的最后部分是<code>connect(self.CalculateTax)</code>。这意味着这个按钮会被链接到一个叫做<code>self.CalculateTax</code> 的函数，这样以后每当用户按下这个按钮的时候，这段代码都会被调用。</p>
<p>我们还没有实现这个函数。所以让我们动手开始写吧。</p>
<p>在<code>MyApp</code> 类中，添加另外一个函数。我们需要先看看整个函数，然后再去了解它的细节：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
</td>
<td>
<p><code>def</code> <code>CalculateTax(</code><code>self</code><code>):</code></p>
<p><code>        </code><code>price </code><code>=</code> <code>int</code><code>(</code><code>self</code><code>.price_box.toPlainText())</code></p>
<p><code>        </code><code>tax </code><code>=</code> <code>(</code><code>self</code><code>.tax_rate.value())</code></p>
<p><code>        </code><code>total_price </code><code>=</code> <code>price  </code><code>+</code> <code>((tax </code><code>/</code> <code>100</code><code>) </code><code>*</code> <code>price)</code></p>
<p><code>        </code><code>total_price_string </code><code>=</code> <code>"The total price with tax is: "</code> <code>+</code> <code>str</code><code>(total_price)</code></p>
<p><code>        </code><code>self</code><code>.results_window.setText(total_price_string)</code></p>
</td>
</tr>
</tbody>
</table>
<p>好了，让我们一行一行的分析上面的代码。</p>
<p>我们现在要做两件事：读取价格和税率，然后计算最终的价格。好了开始吧。请记住，我们要通过我们设定的名字来调用这些组件（这就是我让你不要用默认的通用名称比如<code>box1</code> 的原因，否则的话我们在写代码的时候会很恼火）。</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
</td>
<td>
<p><code>price </code><code>=</code> <code>int</code><code>(</code><code>self</code><code>.price_box.toPlainText())</code></p>
</td>
</tr>
</tbody>
</table>
<p><code>price_box.toPlainText()</code> 是一个内置的可以读取输入框中的值的函数。顺便提一句，虽然你用得多了以后肯定能记住这些函数，因为他们的名字取得很规范，但是你没必要一开始就去记忆所有这些函数。我每次都是通过 Google 诸如 “Qt Textbox 读取数据”一类的关键字来找到我所需要的函数。</p>
<p>通过函数读取到的是一个 string 类型的值，所以我们需要把他转换成 integer 类型并存在一个<code>price</code>变量中。</p>
<p>然后读取税率：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
</td>
<td>
<p><code>tax </code><code>=</code> <code>(</code><code>self</code><code>.tax_rate.value())</code></p>
</td>
</tr>
</tbody>
</table>
<p>同样的，<code>value()</code> 是读取<code>spinbox</code> 中值的函数。感谢 Google。</p>
<p>我们现在已经得到了以上两个值，这样我们就能用非常高大上的数学公式来计算我们的最终价格了：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
</td>
<td>
<p><code>total_price </code><code>=</code> <code>price  </code><code>+</code> <code>((tax </code><code>/</code> <code>100</code><code>) </code><code>*</code> <code>price)</code></p>
<p><code>total_price_string </code><code>=</code> <code>"The total price with tax is: "</code> <code>+</code> <code>str</code><code>(total_price)</code></p>
</td>
</tr>
</tbody>
</table>
<p>我们新建了一个 string 变量来储存我们的最终价格。因为最终直接显示在应用上的将会是一个 string 类型的值：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
</td>
<td>
<p><code>self</code><code>.results_window.setText(total_price_string)</code></p>
</td>
</tr>
</tbody>
</table>
<p>在<code>results_window</code> 中，我们调用了<code>setText()</code> 函数，它能显示我们计算出的最终价格的字符串。</p>
<p>最后运行我们写好的程序：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
</td>
<td>
<p><code>python pyqt_first.py</code></p>
</td>
</tr>
</tbody>
</table>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180YWEyNTBkZDQwMjk2MzNkYjVkMjQ0NGU0MjNlZDk5NC5qcGc=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19iZjVkN2NlMjViNTNlNTM1YWVlNDRmMjkxNTE2YWIxNC5qcGc=.jpg"></p>
<p>好了，这就是一个简单的 PyQt 教程。</p>
<p>如果你还想要体验更多好玩儿的东西，你可以试着用一用别的组件，不过先提醒一句，你要是放了太多的组件在你的应用中的话，用起来可能会有点费劲…</p>
<h3>关于作者： <a href="http://python.jobbole.com/author/zhanglintc/" rel="external nofollow noreferrer">Lane</a></h3>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-04 20:21:49</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/python/" title="python">python</a>, <a href="https://www.iamivan.net/tag/gui/" title="gui">gui</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>使用PyQt来编写第一个Python GUI程序的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0bokogb.html" rel="bookmark">使用NetBeans IDE设计一个Swing GUI程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				教程中您将会学到如何: 使用GUI Builder 界面 创建一个 GUI 容器 添加组件 调整组件大小 对齐组件 调整组件锚距 设置组件自动调整大小行为 编辑组件属性 本教程大约需要30分钟的时间完成. 注意:当您看到 图示,表示您可以通过点击它查看更为详细的GUI Builder相关功能的交互式解说. 入门 IDE的GUI Builder能让那些没有深入了解布局管理的用户创建一个具有专业级外观的GUI应用变为可能. 有关GUI Builder的可视化反馈描述,您可以查阅 GUI Builde			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6YeqAb.html" rel="bookmark">Android开发之编写第一个Android应用程序实现按钮和复选框</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				搞Android系统这么久了,说实话,我连apk怎么写还真是不会,说实话能够看懂,简单改改就不错了,说来惭愧,我是嵌入式出身.最近开始学习Android应用开发,和我的底层结合起来,为了工作,咬着牙也要学下去!!! 首先,我使用的是Android Studio这个软件. 上谷歌中国网就可以下载到了,地址如下: https://developer.android.google.cn/develop/index.html     编译环境配置,找百度看看就行了,这里不哆嗦.     安装好后,有一些			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8Zwxlb.html" rel="bookmark">Python 爬虫程序 PySpider</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 PySipder 是一个 Python 爬虫程序演示地址:**://demo.pyspider.org/使用 Python 编写脚本,提供强大的 APIPython 2&amp;3强大的 WebUI 和脚本编辑器.任务监控和项目**和结果查看支持 JavaScript 页面后端系统支持:MySQL, MongoDB, SQLite, Postgresql支持任务优先级.重试.定期抓取等分布式架构示例代码:from pyspider.libs.base_handler import * cl**			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5OJOqb.html" rel="bookmark">《21天学通C语言（第6版&bull;修订版）》一1&period;5 第一个C语言程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.5 第一个C语言程序 21天学通C语言(第6版•修订版)读者也许迫不及待地想编写第一个C语言程序.为帮助读者熟悉编译器,程序清单1.1包含一个小型程序,功能快速地完成.现在,读者也许无法理解其中的所有内容,但不用担心,尽管编写.编译并运行它. 这里的演示使用的是一个名为hello.c的程序,该程序只是将单词&quot;Hello, World!&quot;显示到屏幕上而已.该程序常被用来介绍C语言编程,很适合读者进行学习.程序清单1.1列出了hello.c的源代码.输入该程序清单时,请不要输入最左边的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEQA2qb.html" rel="bookmark">《Python语言程序设计》&mdash;&mdash;2&period;2　编写一个简单的程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.2 编写一个简单的程序 关键点:编写一个涉及设计解决问题的策略的程序,然后使用程序设计语言实现这些策略.首先,让我们来看一个计算圆面积的简单问题.我们该如何编写程序来解决这个问题呢?编写程序涉及如何设计算法以及如何将算法翻译成程序设计指令或代码.当你编写代码时--即你在编写程序时--你就将一个算法翻译成一段程序.算法描述的是如何通过列出要进行的动作和这些动作的执行顺序来解决一个问题.算法可以帮助程序员在使用程序设计语言编程之前做一个规划.算法可以用自然语言或伪代码(即自然语言与某些程序设计代			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7Jyjz.html" rel="bookmark">PyQt4 Python GUI窗体应用程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 还是一句老话,公司要什么我就做什么.这次来玩Python的GUI编程,做一个用于监控警报.简化SOP的窗体应用程序.首先当然是部署开发环境了,这次用PyCharm5+Python3.4+PyQt4(QT Designer) 软件环境 系统  Win10 软件  Python 3.4.3 PyCharm 5.0.4 PyQt 4 IPython 4.0.0 Powershell 3.0 PyQT简介 PyQt是一个创建GUI应用程序的工具包.它是Python编程语言和Qt库的成功融合.Qt库			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV0Zm4M.html" rel="bookmark">Windows中使用wxPython和py2exe开发Python的GUI程序的实例教程&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Python是支持可视化编程,即编写gui程序,你可以用它来编写自己喜欢的桌面程序.使用wxPython来做界面非常的简单,只是不能像C#一样拖动控件,需要自行写代码布局.在完成编写之后,由于直接的py文件不能再没有安装python的电脑上运行,能否有一个打包成在任意电脑都能运行的工具,网上找找发现了py2exe正好可以完成这个功能.wxPython和py2exe都是开源免费软件. 环境配置wxPython: sourceforge项目页https://sourceforge.net/proje			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeadq9z.html" rel="bookmark">PyQt 4&period;8&period;5发布 创建GUI应用程序的工具包</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PyQt 4.8.5这是一个小的错误修正版. PyQt是一个创建GUI应用程序的工具包.它是Python编程语言和Qt库的成功融合.Qt库是这个星球上最强大的库之一,在更强大库出现之前.PyQt是由http://www.aliyun.com/zixun/aggregation/29869.html&quot;&gt;Phil Thompson 开发. PyQt实现了一个Python模块集.它有超过300类,将近6000个函数和方法.它是一个多平台的工具包,可以运行在所有主要操作系统上,包括UNIX,Win			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bojkeVz.html" rel="bookmark">PyQt v4&period;8&period;3发布 创建GUI应用程序的工具包</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PyQt是一个创建GUI应用程序的工具包.它是Python编程语言和Qt库的成功融合.Qt库是这个星球上最强大的库之一,在更强大库出现之前.PyQt是由http://www.aliyun.com/zixun/aggregation/29869.html&quot;&gt;Phil Thompson 开发. PyQt实现了一个Python模块集.它有超过300类,将近6000个函数和方法.它是一个多平台的工具包,可以运行在所有主要操作系统上,包括UNIX,Windows和Mac. PyQt采用双许可证,开发			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjEK5z.html" rel="bookmark" class="title">通过 PHP 和 Sajax 使用 Ajax（三）</a>
					<div>
						ajax   通过 PHP 和 Sajax 使用 Ajax (三)简单 Ajax 工具包如何把服务器端 PHP 与 JavaScript 集成 Tyler Anderson , 自由作者, Stexa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkOqop.html" rel="bookmark" class="title">ASP&period;NET中的XML表单控件</a>
					<div>
						asp.net|xml|控件 导 读:介绍了有关ASP.NET中XML控件的使用,有个小BUG:在WEBFORM.ASPX中出现的XML控件,其中的transformsource属性设定了样式表文件路 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKwn8M.html" rel="bookmark" class="title">Win2003下Exchange2003部署图解之二</a>
					<div>
						2.安装Windows支持工具 然后安装Windows支持工具,这些工具在后续步骤中会用到,在Windows2003操作系统光盘下的SUPPORT TOOL文件下TOOL的文件夹下点击SUPTOOLS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKJDEM.html" rel="bookmark" class="title">将Spring和OpenJPA与WebSphere Application Server一起使用</a>
					<div>
						引言 Spring 是一个简化 J2EE 开发的 Java 框架.它具有用于 J2EE 应用程序的所有各层的功能.它还不强制要求特定的编程模型,因此与运行时环境无关,意味着可以在 Java SE 环境 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91GBgM.html" rel="bookmark" class="title">Windows XP操作系统优化技巧精髓</a>
					<div>
						Windows 操作系统的技巧现在网上很多,让人感觉不知道从何下手,下面的技巧,虽然不多,但是对你使用操作系统都有非常大的帮助,所以今天介绍给大家-- 加快开机与关机的速度: ①选&quot;开始运行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlREY8z.html" rel="bookmark" class="title">php站内搜索关键词变亮的实现方法</a>
					<div>
						 这篇文章主要介绍了php站内搜索关键词变亮的实现方法,以实例形式较为详细的分析了数据库表的创建及针对数据库的搜索关键字高亮的实现技巧,非常具有实用价值,需要的朋友可以参考下     本文实例讲述了p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOawdQM.html" rel="bookmark" class="title">IE安全警告怎么关闭</a>
					<div>
						  自从百度近日开启了HTTPS 安全网页功能之后,每次小编电脑IE浏览器打开百度网页就会弹出一个&quot;安全警告&quot;对话框,提示&quot;是否中查看网页包含的内容将不使用安全的HTTP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3VwEM.html" rel="bookmark" class="title">电脑开机黑屏的原因及解决方法</a>
					<div>
						笔记本电脑开机黑屏的原因及解决方法: 1.开机,出完电脑品牌后,按F8,回车,回车,进安全模式里,高级启动选项,最后一次正确配置,回车,回车,按下去试试! 2.再不行,进安全模式,正常启动,回车,到桌 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJwXop.html" rel="bookmark" class="title">有道词典单词本初体验：多平台同步记忆</a>
					<div>
						学习单词并不是一朝一夕能够完成,尤其英语学习,需要日常的积累才会有很好的效果.有道词典就是一款能够为用户养成日常积累习惯,学习英语的助手.另外搭配手机版同时使用效果将更加明显, 有道词典能够将桌面端与 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3LoEM.html" rel="bookmark" class="title">百度推广客户端怎么注册</a>
					<div>
						  第一步:我们先找到这个软件的注册网站,进入官网找也可以,但找起来麻烦,所以就直接找出来了,它的注册网址是:http://e.baidu.com/ 就会进入到这个在线注册的官网 第二步:点击在线申请 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZvmwz.html" rel="bookmark" class="title">Asp&period;net窗体之间传递SqlDataSource数据的问题</a>
					<div>
						问题描述 Asp.net窗体之间传递SqlDataSource数据的问题 我建了2个Webform窗体(Asp.net),一个Webform1一个Webform2.我在Webform1里面有一个Sql ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWJojb.html" rel="bookmark" class="title">JAVA求两直线交点和三角形内外心的方法&lowbar;java</a>
					<div>
						一.求两直线交点 复制代码 代码如下: class Point {    double x;    double y;     public Point() {        this.x = 0;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6N3xLM.html" rel="bookmark" class="title">jQuery中&dollar;&period;extend&lpar;&rpar;用法实例&lowbar;jquery</a>
					<div>
						本文实例讲述了jQuery中$.extend()用法.分享给大家供大家参考.具体分析如下: $.extend()方法定义如下: jQuery.extend([deep], target, object ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7Amnz.html" rel="bookmark" class="title">asp&period;net-在ASP&period;net中获取Html元素如何并返回Json类型</a>
					<div>
						问题描述 在ASP.net中获取Html元素如何并返回Json类型 在ASP.net中获取Html元素如何并返回Json类型 并且获得Html的所有元素 解决方案 asp.net webservice ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEnL6p.html" rel="bookmark" class="title">这些废弃的 HTML 标签不要用</a>
					<div>
						HTML 已经发展了多年,现在 W3C 已经发布了 HTML 5.1 的提案推荐标准,一些陈旧废弃的标签已经在后继的标准中逐渐消失.这里为大家列出那些已经被废弃 HTML 标签,看看你是不是还在使用它 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NlarM.html" rel="bookmark" class="title">手动安装Cloudera Hadoop CDH</a>
					<div>
						安装版本 hadoop各个组件和jdk版本如下: hadoop-2.0.0-cdh4.6.0 hbase-0.94.15-cdh4.6.0 hive-0.10.0-cdh4.6.0 jdk1.6.0_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7NOkz.html" rel="bookmark" class="title">Android中资源文件assets和res下面raw文件的使用不同点</a>
					<div>
						在建立项目中一般会默认建立assets文件,当然我们还可以在res文件下面建立raw文件夹,这里面都可以存放一些图片,音频或者文本信息,可以供我们在程序当中进行使用,不过他们两个也有不同点: asse ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7yaXp.html" rel="bookmark" class="title">云存储并不完美</a>
					<div>
						很多新闻炒作都称云存储被认为是数据存储解决方案的终极目标,但事实上,云存储(又名托管存储)并不完美.如果使用不当,云存储的作用有可能弊大于利. 1. 云存储:根本不完美 关于云存储不为人知的秘密. 这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1B4kz.html" rel="bookmark" class="title">java-网页地址生成超链接和直接在地址栏输入地址的跳转问题</a>
					<div>
						问题描述 网页地址生成超链接和直接在地址栏输入地址的跳转问题 一个小项目,有登陆验证,问题描述如下: 一.未登陆状态: 取任一页面地址作为目标地址,首先在word中生成超链接,点击之后会跳转到项目的登 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0mR5p.html" rel="bookmark" class="title">matlab如何实现scuc的问题，求源代码</a>
					<div>
						问题描述 matlab如何实现scuc的问题,求源代码 电力系统经济调度问题,一共39个节点,16个机组,11个负载,有最小开,关机时间,考虑机组爬升速率,考虑导纳,预测中午十二点是的状态					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22eKQb.html" rel="bookmark" class="title">cuteeditor-CuteEditor在Html页面使用</a>
					<div>
						问题描述 CuteEditor在Html页面使用 你们有人在Html页面中添加过CuteEditor编译器去替换掉textarea富文本编译器吗? 我在网上看的都是说在ASP.NET中添加的. 解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqrLWb.html" rel="bookmark" class="title">BT为中国农村教育捐资500万元</a>
					<div>
						王冀 (记者 王冀)英国电信(BT)于5月26日与联合国儿童基金会正式启动了一项联合计划,根据计划BT将捐资50万英镑,用于中国西部四省数字技术普及率较低的地区,让6000名学生和1700名教师受益. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAdYOb.html" rel="bookmark" class="title">去哪儿 网和 携程 之间合并的传闻不断发酵</a>
					<div>
						4月15日午间消息,近日去哪儿网和携程之间合并的传闻不断发酵,两家如何合并的猜测也持续进行.去哪儿网CEO庄辰超今日在发出的内部邮件中,首次公开谈及这一问题,他表示:所有谈判都是以去哪儿管理层长期主导 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GqwNp.html" rel="bookmark" class="title">身份证号码前六位所代表的省&comma;市&comma;区&comma; 以及地区编码下载&lowbar;javascript技巧</a>
					<div>
						在我上一篇文章里面,讨论了如何验证15,18位身份证号码的合法性,并能取得一些简单的信息, 比如:身份,生日,性别等. 现在,可以取城市和地区了. 复制代码 代码如下: &lt;script lang ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2lX4M.html" rel="bookmark" class="title">Google专注于搜索将成致命弱点</a>
					<div>
						对搜索市场的专注很可能将成为搜索巨头Google的致命弱点,因为这一市场的增长已经开始放缓,而Google的收入几乎全部来自搜索习惯的业务.此外正是对搜索领域的专注,也许会让Google被蒙上眼睛,从 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ZlWZb.html" rel="bookmark" class="title">&period;Net 下区别使用 ByRef&sol;ByVal 的重要性 分享&lowbar;实用技巧</a>
					<div>
						  一直以来在 VB6 下,参数默认都是按照 ByRef  传送的,(即按地址传送) 而在 .Net(C#,VB.Net) 下, 参数默认是使用 ByVal (即按值传送)  传送的,一直没怎么注意. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44xKLz.html" rel="bookmark" class="title">关于Jquery ajax访问的一个很奇怪的问题，网上找了很久都没找到解决办法。</a>
					<div>
						问题描述 通过点击一个按钮ajax访问一个jsp页面 原本想是点击按钮的时候加载一个div 防止用户再点击但现在是ajax访问的页面返回东西的时候那个div才出来.但是奇怪的是加个alert语句的时候 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwyKnvM.html" rel="bookmark" class="title">C&plus;&plus;第13周项目2 - 多重继承教师类和干部类</a>
					<div>
						课程首页地址:http://blog.csdn.net/sxhelijian/article/details/7910565,本周题目链接:http://blog.csdn.net/sxhelijia ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqOngp.html" rel="bookmark" class="title">Android 仿百合网超火爆社交app首页滑动效果</a>
					<div>
						探探,百合网等神器的首页有一个相册加载个控件,通过左滑右滑加载新的照片,同时左滑丢弃这个照片,右滑则表明对这个照片感兴趣. 这个效果是怎么实现的呢? 1,Android3.0以后控件中增加了setTr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwy5wkM.html" rel="bookmark" class="title">数据刷新时，滚动条的问题</a>
					<div>
						问题描述 现在有一个每5秒刷新一次的store,但是没刷新一次,相应的panel里的滚动条就会复位到顶部,查看数据很不方便,该怎么办? 问题补充:babydeed 写道 解决方案 看http://37 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.055 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
